package book;

import book.actions.AddAction;
import book.actions.EditAction;
import book.actions.LoadTableAction;
import book.actions.RemoveAction;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class PhoneBookServlet extends HttpServlet {
    private Map<String, IPhoneBookAction> _actions = new HashMap<String,IPhoneBookAction>();

    public PhoneBookServlet() {
        RecordsBook recordsBook = new RecordsBook();

        _actions.put("add", new AddAction(recordsBook));
        _actions.put("edit", new EditAction(recordsBook));
        _actions.put("remove", new RemoveAction(recordsBook));
        _actions.put("loadtable", new LoadTableAction(recordsBook));
    }

    protected void doGet(HttpServletRequest aHttpServletRequest, HttpServletResponse aHttpServletResponse) throws ServletException, IOException {
        processAJAX(aHttpServletRequest, aHttpServletResponse);
    }

    protected void doPost(HttpServletRequest aHttpServletRequest, HttpServletResponse aHttpServletResponse) throws ServletException, IOException {
        processAJAX(aHttpServletRequest, aHttpServletResponse);
    }

    private void processAJAX(HttpServletRequest aRequest, HttpServletResponse aResponse) throws IOException {
        String actionName = aRequest.getParameter("action").toLowerCase();
        IPhoneBookAction action = _actions.get(actionName);
        String result = action.processAJAX(aRequest);
        if (result != null) {
            aResponse.getWriter().write(result);
        }
    }
}
