package phoneBook.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface PhoneBookService extends RemoteService {
    public String[][] getRecords();
    public void addRecord(String aPhone, String aName, String aComment); 
    public void removeRecord(String aPhone);
    public void editRecord(String aOldPhone, String aNewPhone, String aName, String aComment); 

    public static class App {
        private static PhoneBookServiceAsync app = null;

        public static synchronized PhoneBookServiceAsync getInstance() {
            if (app == null) {
                app = (PhoneBookServiceAsync) GWT.create(PhoneBookService.class);
                ((ServiceDefTarget) app).setServiceEntryPoint(GWT.getModuleBaseURL() + "/PhoneBookService");
            }
            
            return app;
        }
    }
}
