package phoneBook.server;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import book.Record;
import book.RecordsBook;
import phoneBook.client.PhoneBookService;

public class PhoneBookServiceImpl extends RemoteServiceServlet implements PhoneBookService {
    private RecordsBook _recordsBook = new RecordsBook();

    public String[][] getRecords() {
        return _recordsBook.getAllRecordsAsStrings();
    }

    public void addRecord(String aPhone, String aName, String aComment) {
        _recordsBook.addRecord(new Record(aPhone, aName, aComment));
    }

    public void removeRecord(String aPhone) {
        _recordsBook.removeRecord(aPhone);
    }

    public void editRecord(String aOldPhone, String aNewPhone, String aName, String aComment) {
        _recordsBook.editRecord(aOldPhone, new Record(aNewPhone, aName, aComment));
    }
}
